#include <stdio.h>
#include <stdbool.h>


// Tableaux


int main()
{
	// on crée un tableau d'entiers, de taille 6.
	// Si on avait juste écrit int nbrs[6]; on aurait
	// créé le tableau mais sans initialiser ses valeurs.
	int nbrs[6] = {2, 6, 12, 5, 17, -3};
	int a = 12345;
	int b = 6789;

	// On affiche le contenu de chaque case
	for (int i = 0; i < 6; ++i)
	{
		printf("%d\n", nbrs[i]); 
	}

	// On peut afficher des cases mémoires hors du tableau
	// car C ne vérifie pas que l'on accède à des cases valides !
	// On peut alors voir que les variables a et b sont stockées
	// juste à côté du tableau.
	for (int i = -5; i < 10; ++i)
	{
		printf("nbrs[%d] = %d\n", i, nbrs[i]); 
	}

	// nbrs est un tableau, donc c'est un pointeur. Si on affiche
	// le contenu de nbrs, on obtient une adresse, celle du premier
	// entier du table.
	// (hors programme) Sur les pointeurs, faire + 1 ajoute en réalité
	// sizeof(le type du pointeur). Ainsi, nbrs + 1 est l'adresse de la
	// deuxième case du tableau ! 
	printf("La première case a pour adresse %p; la deuxième %p\n", nbrs, nbrs+1);
	printf("%p %p\n", &a, &b);
	return 0;
}
